Unit QS19R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS11_p;

procedure QS19R(var RINT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                L :Integer; var XA :Array of Real;
                var XB :Array of Real; var RA :Array of Real;
                var RB :Array of Real; var IERR :Integer);

implementation

procedure QS19R(var RINT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                L :Integer; var XA :Array of Real;
                var XB :Array of Real; var RA :Array of Real;
                var RB :Array of Real; var IERR :Integer);
var
I,I0,I1,K,K0,M,N :Integer;
E0,H,RA1,RA2,RB1,RB2,RI,X0,X1,XA1,XA2,XB1,XB2 :Real;
C :Array [0..15] of Real;
X :Array [0..15] of Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140;
begin
{   DATA  FORTRAN  }
X[0] := 0.498631930925;
X[1] := 0.492805755773;
X[2] := 0.482381127794;
X[3] := 0.467453037969;
X[4] := 0.448160577883;
X[5] := 0.424683806866;
X[6] := 0.397241897984;
X[7] := 0.36609105937;
X[8] := 0.331522133465;
X[9] := 0.29385787862;
X[10] := 0.253449954466;
X[11] := 0.210675638065;
X[12] := 0.165934301141;
X[13] := 0.119643681126;
X[14] := 0.072235980791;
X[15] := 0.024153832844;
C[0] := 0.003509305005;
C[1] := 0.008137197365;
C[2] := 0.012696032655;
C[3] := 0.017136931457;
C[4] := 0.021417949011;
C[5] := 0.025499029631;
C[6] := 0.029342046739;
C[7] := 0.032911111388;
C[8] := 0.036172897054;
C[9] := 0.039096947894;
C[10] := 0.041655962113;
C[11] := 0.043826046502;
C[12] := 0.045586939348;
C[13] := 0.04692219954;
C[14] := 0.04781936004;
C[15] := 0.048270044257;
N := L;
IERR := 0;
K := -1;
if ( A  <>  B )
 then goto _10;
RINT := 0.0;
goto _140;
_10:
K := N;
XA1 := XA[0];
XB1 := XB[0];
H := XA[1] - XA1;
X1 := XA1 + 0.5*H;
M := 20;
goto _110;
_20:
RA[0] := RI;
RA[1] := 0.5*RI;
RA1 := RI;
H := XB1 - XB[1];
X1 := XB1 - 0.5*H;
M := 30;
goto _110;
_30:
RB[0] := RI;
RB[1] := 0.5*RI;
RB1 := RI;
//
I := 3;
while I<=K do
 begin
  K0 := I;
  XA2 := XA[I-1];
  H := XA2 - XA[I-2];
  X1 := XA2 - 0.5*H;
  M := 40;
  goto _110;
_40:
  RA[0] := RA[0] + RI;
  RA[I-1] := RA[0];
  XB2 := XB[I-1];
  H := XB[I-2] - XB2;
  X1 := XB2 + 0.5*H;
  M := 50;
  goto _110;
_50:
  RB[0] := RB[0] + RI;
  RB[I-1] := RB[0];
  for I1:=2 to I do
   begin
    I0 := I1;
    RA2 := RA[I1-1];
    RA[I1-1] := 0.5*(RA[I1-2] + RA1);
    RB2 := RB[I1-1];
    RB[I1-1] := 0.5*(RB[I1-2] + RB1);
    E0 := Abs(RA[I1-1] - RA1) + Abs(RA[I1-2] - RA1) +
    Abs(RB[I1-1] - RB1) + Abs(RB[I1-2] - RB1);
    if ( E0  <=  E )
     then goto _80;
    RA1 := RA2;
    RB1 := RB2;
_60:
   end;
_70:
  inc(I);
 end;
IERR := 65;
UTQS11(IERR,16);
_80:
RINT := RA[I0-1] + RB[I0-1];
K := K0;
H := XA1 - A;
if ( H  <=  0.0 ) 
 then goto _100;
X1 := A + 0.5*H;
M := 90;
goto _110;
_90:
RINT := RINT + RI;
_100:
H := B - XB1;
if ( H  <=  0.0 ) 
 then goto _140;
X1 := B - 0.5*H;
M := 130;
_110:
RI := 0.0;
for I1:=1 to 16 do
 begin
  X0 := H*X[I1-1];
  RI := RI + C[I1-1]*(F(X1+X0) + F(X1-X0));
_120:
 end;
RI := H*RI;
if ( M=20 ) then goto _20 else
if ( M=30 ) then goto _30 else
if ( M=40 ) then goto _40 else
if ( M=50 ) then goto _50 else
if ( M=90 ) then goto _90 else
if ( M=130 ) then goto _130;
_130:
RINT := RINT + RI;
_140:
end;

end.
